package com.frikinjay.lmd.handlers;

import com.destroystokyo.paper.event.entity.EntityRemoveFromWorldEvent;
import com.frikinjay.lmd.LetMeDespawn;
import java.util.Objects;
import org.bukkit.Bukkit;
import org.bukkit.Material;
import org.bukkit.World;
import org.bukkit.entity.LivingEntity;
import org.bukkit.entity.SpawnCategory;
import org.bukkit.event.EventHandler;
import org.bukkit.event.EventPriority;
import org.bukkit.event.Listener;
import org.bukkit.event.entity.EntityPickupItemEvent;
import org.bukkit.inventory.ItemStack;
import org.bukkit.persistence.PersistentDataType;

public class DespawnHandler implements Listener {
   public DespawnHandler(LetMeDespawn plugin) {
      Bukkit.getPluginManager().registerEvents(this, plugin);
   }

   @EventHandler(
      priority = EventPriority.LOW
   )
   public void onMobDespawn_Low(EntityPickupItemEvent event) {
   }

   @EventHandler
   public void onMobDespawn_Normal(EntityPickupItemEvent event) {
      if (event.getEntity().getSpawnCategory().equals(SpawnCategory.MONSTER)) {
         LivingEntity entity = event.getEntity();
         new DelayUtil(() -> {
            if (entity.isPersistent()) {
               entity.setRemoveWhenFarAway(true);
               entity.getPersistentDataContainer().set(LetMeDespawn.desp, PersistentDataType.STRING, "despawn");
            }

         }, 1L);
      }
   }

   @EventHandler(
      priority = EventPriority.HIGH
   )
   public void onMobDespawn_High(EntityRemoveFromWorldEvent event) {
      if (event.getEntity().getSpawnCategory().equals(SpawnCategory.MONSTER)) {
         if (Objects.equals(event.getEntity().getPersistentDataContainer().get(LetMeDespawn.desp, PersistentDataType.STRING), "despawn")) {
            LivingEntity entity = (LivingEntity)event.getEntity();
            World world = entity.getWorld();
            ItemStack[] itemsArmor = entity.getEquipment().getArmorContents();
            ItemStack itemMainHand = entity.getEquipment().getItemInMainHand();
            ItemStack itemOffHand = entity.getEquipment().getItemInOffHand();
            ItemStack air = new ItemStack(Material.AIR);
            ItemStack[] var8 = itemsArmor;
            int var9 = itemsArmor.length;

            for(int var10 = 0; var10 < var9; ++var10) {
               ItemStack itemStack = var8[var10];
               if (!itemStack.equals(air)) {
                  world.dropItem(entity.getLocation().clone(), itemStack);
               }
            }

            world.dropItem(entity.getLocation().clone(), itemMainHand);
            world.dropItem(entity.getLocation().clone(), itemOffHand);
         }
      }
   }
}
